/*
 * fancyrunnable.h
 *
 *  Created on: 23.11.2009
 *      Author: wglas
 */

#include <fancyobject.h>

#ifndef FANCYRUNNABLE_H_
#define FANCYRUNNABLE_H_

namespace Fancy {

/**
 * An interface for a general runnable object with a bare @c run() method.
 */
class FANCYBASE_API Runnable : virtual public Object {
public:
    typedef ObjPtr<Runnable> ptr_t;

    virtual void run() = 0;

protected:
    Runnable() {}
    virtual ~Runnable();
};

}

#endif /* FANCYRUNNABLE_H_ */
